<template>
  <el-container style="flex-grow:1">
    <el-main class="containMain">
      <div class="contentTitle">盲乳登记</div>
      <el-form ref="form" :model="formData" label-width="80px" style="margin-top:20px;">
        <el-form-item label label-width="0">
          <!-- <el-input v-model="formData.cowID" clearable prefix-icon="el-icon-search" style="width:300px" maxlength="8"></el-input>
          <el-button type="primary" @click="getNowCow" style="width:90px;margin-left:12px">确认</el-button> -->
          <el-autocomplete prefix-icon="el-icon-search" v-model="formData.cowID" :fetch-suggestions="queryCow" placeholder="请输入牛号" style="width:300px" clearable @select="getNowCow"></el-autocomplete>
        
        </el-form-item>

        <div class="sub" v-if="tableData.length>0">操作牛号：{{tableData[0].value}}</div>
        <el-form-item label="乳区状态">
          <div class="list">
            <div class="item" v-for="item in statusList" @click="item.value=!item.value" :class="{active:item.value}">{{item.value?"盲乳":item.name}}</div>
          </div>
        </el-form-item>
        <div style="margin-top:80px">
          <el-button @click="onSave" type="primary" style="width:98px;" size="mediu">确认保存</el-button>
        </div>
      </el-form>
    </el-main>
    <el-aside class="containAside" width="450px">
      <div class="asideInfo">
        <div class="contentTitle">牛只信息</div>
        <el-table class="handleTable" border :data="tableData" style="width: 100%" :height="(allHeight-70)+'px'" size="small">
          <el-table-column prop="key" label="参数"></el-table-column>
          <el-table-column prop="value" label="当前牛只信信息"></el-table-column>
        </el-table>
      </div>
    </el-aside>
  </el-container>
</template>
<script>
import formValidator from '../formValidator'
import axios from 'axios'
import { mapState } from 'vuex'
export default {
  created() {


  },
  data() {
    return {
      saving: false,
      formData: {
        cowID: '',
        checkDate: Date.parse(new Date()),
      },
      statusList: [
        {
          key: '_FL',
          value: false,
          name: '左前',
          befor: false
        }, {
          key: '_FR',
          value: false,
          name: '右前',
          befor: false
        }, {
          key: '_BL',
          value: false,
          name: '左后',
          befor: false
        }, {
          key: '_BR',
          value: false,
          name: '右后',
          befor: false
        }
      ],
      rules: {
        icon: [
          { required: true, message: '请上传头像', trigger: 'blur' },
        ],
        username: [
          { required: true, message: '请输入昵称', trigger: 'blur' },
        ],
        phone: [
          { required: true, message: '请输入手机号', trigger: 'blur' },
          {
            validator: (rule, value, callback) => {
              if (!value) {
                callback(new Error('请输入手机号'));
              } else if (/^1[3-9]\d{9}$/.test(value)) {
                callback();
              } else {
                callback(new Error('请输入正确的手机号'));
              }
            }, trigger: 'blur'
          }
        ],
        password: [
          { required: true, message: '请输入密码', trigger: 'blur' },
        ],
        roleId: [
          { required: true, message: '请选择角色', trigger: 'blur' },
        ]
      },
      roles: [],
      departs: [],
      allReason: [],
      LeftClass: [],
      LeftWhere: [],
      tableData: [],
      editRow:{}
    }
  },
  computed: {
    ...mapState(['userInfo', 'allHeight']),
    reasons() {
      var list = []
      this.allReason.forEach(item => {
        if (list.indexOf(item['类别']) == -1) {
          list.push(item['类别'])
        }
      })
      return list
    },
    remarks() {
      var list = []
      if (this.formData.reason) {
        this.allReason.forEach(item => {
          if (item['类别'] == this.formData.reason) {
            list.push(item['名称'])
          }
        })
      }
      return list
    }
  },
  watch: {
    'formData.reason'() {
      setTimeout(() => {
        this.formData.remark = this.remarks[0]
      }, 100)
    },
    'formData.cowID'() {
      if (this.formData.cowID.length != 8) {
        return
      }
      this.getNowCow()
    }
  },
  methods: {
    onSave() {
      if (this.formData.cowID!=this.editRow['牛号']) {
        this.$message({
          message: '请录入离场牛只牛号',
          type: 'warning'
        });
        return
      }
      var formData = { ...this.formData }
      formData.checkDate = Date.parse(new Date())

      this.statusList.forEach(item => {
        formData['status' + item.key] = item.value
        if (item.befor && !item.value) {
          formData['removeDate' + item.key] = Date.parse(new Date())
          formData['removeMan' + item.key] = this.userInfo.username
        }

        if (item.value) {
          formData['markDate' + item.key] = Date.parse(new Date())
          formData['markMan' + item.key] = this.userInfo.username
        }
      })



      this.getHaleInfo('wsVeterinary', 'addBlind', [
        formData
      ], 'json').then((data) => {
        // console.log(data)
        if (data.rtnCode == -1) {
          this.$message({
            message: data.rtnMessage,
            type: 'warning'
          });
          this.formData.cowID = ''
        }
        else {
          this.$message({
            message: '盲乳录入成功',
            type: 'success'
          });
          this.formData.cowID = ''
        }
      })
    },
    submit() {
      var data = JSON.parse(JSON.stringify(this.formData));
      this.$http.post({
        url: this.formData.id ? '/userInfo/update' : '/userInfo/save',
        data: data
      }).then(res => {
        if (res.success) {
          this.$message.success('成功');
          this.$router.go(-1);
        } else {
          this.$message.warning('失败')
        }
      });
    },
    getNowCow() {
      if (this.formData.cowID.length != 8) {
        this.$message({
          message: '牛号错误',
          type: 'warning'
        });
        return
      }
      this.getHaleInfo('wsVeterinary', 'getBlindByCowID', [
        this.formData.cowID
      ], 'json').then((data) => {
        this.editRow=data
        // console.log(data)
        data = this.JsonSort(['牛号', '当前牛舍'], data)
        var list = []
       list.push({
            key: '牛号',
            value:data['牛号']
          })
         list.push({
            key: '左前乳区状态',
            value:'正常'
          })
           list.push({
            key: '右前乳区状态',
            value:'正常'
          })
           list.push({
            key: '左后乳区状态',
            value:'正常'
          })
           list.push({
            key: '右后乳区状态',
            value:'正常'
          })


        if (data['左前乳区状态'] == 'true') {
          this.statusList[0].value = true
          this.statusList[0].befor = true
          list[1].value='盲乳'
        }
        else {
          this.statusList[0].value = false
          this.statusList[0].befor = false
        }


        if (data['右前乳区状态'] == 'true') {
          this.statusList[1].value = true
          this.statusList[1].befor = true
           list[2].value='盲乳'
        }
        else {
          this.statusList[1].value = false
          this.statusList[1].befor = false
        }


        if (data['左后乳区状态'] == 'true') {
          this.statusList[2].value = true
          this.statusList[2].befor = true
           list[3].value='盲乳'
        }
        else {
          this.statusList[2].value = false
          this.statusList[2].befor = false
        }


        if (data['右后乳区状态'] == 'true') {
          this.statusList[3].value = true
          this.statusList[3].befor = true
           list[4].value='盲乳'
        }
        else {
          this.statusList[3].value = false
          this.statusList[3].befor = false
        }



        // console.log(list)

        this.tableData = list
      }).catch(() => {
        this.formData.cowID = ''
      })
    }
  }
}
</script>
<style lang="less" scoped>
.containMain {
  background: rgba(255, 255, 255, 1);
  border-radius: 4px;
  padding: 15px;
  // margin-right: 10px;
  .contentTitle {
    border-bottom: 1px solid #f2f4f5;
  }
  // min-width: 450px;

  .sub {
    font-size: 14px;
    font-weight: 600;
    color: rgba(102, 102, 102, 1);
    line-height: 20px;
    margin-bottom: 40px;
    padding-left: 20px;
  }
}

.contentTitle {
  font-size: 16px;
  font-weight: bold;
  color: rgba(0, 0, 0, 1);
  line-height: 22px;
  letter-spacing: 1px;
  padding-bottom: 14px;
}

.containAside {
  padding: 0;
  margin-left: 10px;
  display: flex;
  flex-direction: column;
  .asideInfo {
    flex-grow: 1;
    background: rgba(255, 255, 255, 1);
    border-radius: 4px;
    padding: 15px;
  }
}

.list {
  display: flex;
  flex-wrap: wrap;
  width: 130px;
  justify-content: space-between;

  .item {
    width: 60px;
    height: 60px;
    background: rgba(133, 195, 6, 1);
    border-radius: 4px;
    margin-bottom: 10px;
    font-size: 13px;
    font-weight: bold;
    line-height: 60px;
    text-align: center;
    color: rgba(255, 255, 255, 1);
    cursor: pointer;

    &.active {
      background: rgba(0, 70, 104, 1);
    }
  }
}
</style>
